
--[[
    Paramvir 2020
    This is the data file for wxshowimage.lua

    -- showimage options
	-- -a 	add transparency value 1 to 100 - 100 being opaque
	-- -b 	pan image - separate values with colon : character x-axis:y-axis
	-- -e 	enlarge / zoom / scale of background image -
	--      the image will increase x times the value
	-- -i 	Image with full path
	-- -n 	showimage
	-- -p 	Position x,y co-ordinates for the widget.
    -- -s 	Size height,width co-ordinates for the widget.
]]

local w = {true}

w.dt = {
    origin         = '0,0',
    path           = '/tmp/wx-param-conkywx-02.conf-pChA_r_27u0-m39/',
    zoom           = 7,
    alpha          = 75,
    errorImageSize = '1000x700',
    size           = '700,360',
}


w.ds = {
    {
        -- ${lua main -n showimage -i ${template1} -e 8 -s 760,300 -p 0,0 -b -140:+230 -a 65 }${else}No CIMSS Surface Analysis Image
        name           = 'gsi_image.gif',
        origin         = w.dt.origin,
        zoom           = 7.2,
        path           = w.dt.path,
        alpha          = w.dt.alpha,
        pan            = '-50:150',
        size           = w.dt.size,
        errorMsg       = 'No CIMSS Surface Analysis Image',
        errorImageSize = w.dt.errorImageSize,
        imageNo        = 0,
    },
    {
        -- '${lua main -n showimage -i ${template3} -e 7.0 -s 720,300 -p 0,0 -b -20:-60 -a 65 }${else}${goto 510}No Intellicast Surface Analysis Image'
        name           = 'gisi_image_sat.jpg',
        origin         = w.dt.origin,
        zoom           = w.dt.zoom,
        path           = w.dt.path,
        alpha          = w.dt.alpha,
        pan            = '-20:-60',
        size           = w.dt.size,
        errorMsg       = 'No Intellicast Surface Analysis Image',
        errorImageSize = w.dt.errorImageSize,
        imageNo        = 1,
    },
    {
        -- ${lua main -n showimage -i ${template4} -e 7 -s 720,300 -p 0,0 -b -50:50 -a 65 }${else}${goto 510}No NOAA cyclone image
        name           = 'gl_sst_mm.gif',
        origin         = w.dt.origin,
        zoom           = w.dt.zoom,
        path           = w.dt.path,
        alpha          = w.dt.alpha,
        pan            = '-50:50',
        size           = w.dt.size,
        errorMsg       = 'No NOAA cyclone image',
        errorImageSize = w.dt.errorImageSize,
        imageNo        = 2,
    },
    {
        -- ${lua main -n showimage -i ${template8} -e 7.0 -s 720,300 -p 0,0 -b -20:-60 -a 65 }${else}${goto 510}No Intellicast Surface Analysis Image
        name           = 'gisi_image_sur.jpg',
        origin         = w.dt.origin,
        zoom           = w.dt.zoom,
        path           = w.dt.path,
        alpha          = w.dt.alpha,
        pan            = '-20:-60',
        size           = w.dt.size,
        errorMsg       = 'No Intellicast Surface Analysis Image',
        errorImageSize = w.dt.errorImageSize,
        imageNo        = 3,
    },
    {
        -- ${lua main -n showimage -i ${template6} -e 7.0 -s 650,300 -p 0,0 -b 0:200 -a 65 }${else}${goto 510}No CISS Water Vapour image
        name           = 'wv_image.gif',
        origin         = w.dt.origin,
        zoom           = w.dt.zoom,
        path           = w.dt.path,
        alpha          = w.dt.alpha,
        pan            = '0:100',
        size           = w.dt.size,
        errorMsg       = 'No CISS Water Vapour image',
        errorImageSize = w.dt.errorImageSize,
        imageNo        = 4,
    },
    {
        -- ${lua main -n showimage -i ${template7} -e 7.0 -s 650,300 -p 0,0 -b 0:50 -a 85 }${else}${goto 510}No Thai Met Surface Analysis image
        name           = 'thaiSurface.jpg',
        origin         = w.dt.origin,
        zoom           = w.dt.zoom,
        path           = w.dt.path,
        alpha          = 85,
        pan            = '0:50',
        size           = w.dt.size,
        errorMsg       = 'No Thai Met Surface Analysis image',
        errorImageSize = w.dt.errorImageSize,
        imageNo        = 5,
    },
    {
        -- ${lua main -n showimage -i ${template9} -e 7.0 -s 650,300 -p 0,0 -b 0:70 -a 85 }${else}${goto 510}No Thai Met Wind image
        name           = 'thaiWind.jpg',
        origin         = w.dt.origin,
        zoom           = w.dt.zoom,
        path           = w.dt.path,
        alpha          = 85,
        pan            = '0:70',
        size           = w.dt.size,
        errorMsg       = 'No Thai Met Wind image',
        errorImageSize = w.dt.errorImageSize,
        imageNo        = 6,
    },

}

return w
