package tides;

=comments
    Parses tides
    This version (c) 2019 Paramvir Likhari
=cut

$tides::VERSION = '9';

require Exporter;
@tides::ISA = qw(Exporter);
@tides::EXPORT = qw(doTides); # function to export

use strict;
use warnings;


sub msgout  { print STDERR "@_ \n" }

## any reference to functions in the main program can be called like main::calltofunction()

sub doTides {

    my ( $temppath, $tForm, $noFileMsg, $ttime, ${year}, $yday,$tide_data, $tide_days_opt, $tide_days_num, $tide_date, $tide_date_format, $zero_pad_tide_ht ) = @_ ;

    my ( @tset, $cnt,  ) ;

    # my %tdhl  = ( "High Tide" => "HT", "Low Tide"  => "LT" );
    my %tdhl  = ( "high" => "HT", "low"  => "LT" );
    # my$tForm = $timeFormat{$conf{Time_format}} // $conf{Time_format} ;

    my $tideFormat = sub {
        my ($time1, $ht1, $htlt1) = @_;
        $time1 = main::time2str($tForm, $time1);
        $ht1   = main::convert_unit($ht1,'Tide');
        $htlt1 = $tdhl{$htlt1};
        if ( $zero_pad_tide_ht ) {
            my ($f1, $s1) = split(' ', $ht1);
            $f1 = "0$f1" if $f1 < 10;
            $ht1 = "$f1 $s1" ;
        }
        return "${time1}  ${ht1}  ${htlt1}";
    };

    $tide_days_opt = ( $tide_days_opt ) ? $tide_days_opt  : 1        ;
    $tide_days_num = ( $tide_days_num ) ? $tide_days_num  : 7        ;
    $tide_date     = ( $tide_date     ) ? $tide_date      : 'monday' ;

    if ($tide_data and -e $tide_data ) {
        my ( $tidestr  ) ;
        {
        open (FILE, "<", "$tide_data") or die "$noFileMsg main data file $!";
            local $/ = undef;
            $tidestr = <FILE> ;
        close (FILE);
        }
        # my $ttime = "${hour}:${min}:${sec}" ;

        # my $tndstr = ${main::get_line_num( \$tidestr,'window.FCGON = {','};','str')};
        my $tndstr = ${main::get_line_num( \$tidestr,'"tides":[{','}],','str')};

        # $tndstr =~ s/window.FCGON =/\{"data":/;
        # $tndstr =~ s/$/\}\}/;
        $tndstr =~ s/"tides":\[\{/\{"data":{"tides":\[\{/;
        $tndstr =~ s/$/\}\]\}\}/;

        # msgout($tndstr);

        # die;
        my $wxtide = main::jsonParser( $tndstr );


        # msgout($#{$$wxtide{data}{tides}});
        # for my $k (0..$#{$$wxfct{data}{detail}}) {
        # msgout($$wxtide{data}{tides}[200]{timestamp});

        my ($td_loc) = ($tidestr =~ m{<title>Tide.*?for\s*(.*?)</title>});
        my ($maxHeight) = ($tidestr =~ m{,"maxHeight":(.*?),});

        $td_loc =~ s/[,]/ -/g;

        $maxHeight = main::convert_unit($maxHeight,'Tide');

        $td_loc .= ":\n MaxRange: ${maxHeight}\n";

        my $firstDay = main::time2str( '%j',$$wxtide{data}{tides}[0]{timestamp});

        my $testDay;

        open (TFILE, '>', "$temppath/tides" ) or die "$$noFileMsg tides file $!";
        print TFILE $td_loc;

        my $cntn = 1;
        for my $k (0..$#{$$wxtide{data}{tides}}) {

            my ($cDay, $ydayt, $tday);

            my $daytime = $$wxtide{data}{tides}[$k]{timestamp};

            $cDay = main::time2str( '%j#%A %d %B',"$daytime");
            ($ydayt, $tday) = split(/#/, $cDay) ;

            $cntn = $ydayt - $firstDay + 1 ;

            if ( $testDay and $testDay != $ydayt ) {
                undef $testDay
            }

            if ( $tide_days_opt == 1 ) {
                $cnt = ( $ydayt == $yday ) ? 1 : undef
            }
            elsif ( $tide_days_opt == 2 ) {
                $cnt = ( $ydayt <= $yday and $ydayt > ($yday - $tide_days_num) ) ?
                1 : undef
            }
            elsif ( $tide_days_opt == 3 ) {
                $cnt = ( $ydayt >= $yday and $ydayt < ($yday + $tide_days_num) ) ?
                1 : undef
            }
            elsif ( $tide_days_opt == 4 ) {
                $cnt = 1
            }
            else {
                undef $cnt
            }

            if ( $tide_days_opt == 5) {
                if ( $tday =~ /\b$tide_date/i ) {
                    # print TFILE "${tday}\n";
                    if ( not $testDay) {
                        my $dt1 = main::time2str($tide_date_format, $tday );
                        print TFILE "zzz $dt1\n";
                        $testDay = $ydayt ;
                    }
                    my $prn = &$tideFormat($$wxtide{data}{tides}[$k]{time}, $$wxtide{data}{tides}[$k]{height}, $$wxtide{data}{tides}[$k]{type}, $$wxtide{data}{ip_units});
                    print TFILE "$prn\n";
                }
            }
            else {
                if ($cnt) {
                    if ( not $testDay) {
                        my $dt1 = main::time2str($tide_date_format, $tday );
                        # msgout($tday);
                        print TFILE "zzz $dt1\n";
                        $testDay = $ydayt ;
                    }
                    my $prn = &$tideFormat($$wxtide{data}{tides}[$k]{time}, $$wxtide{data}{tides}[$k]{height}, $$wxtide{data}{tides}[$k]{type}, $$wxtide{data}{ip_units});
                    # msgout($$wxtide{data}{tides}[$k]{time}, $$wxtide{data}{tides}[$k]{height}, $$wxtide{data}{tides}[$k]{type}, $$wxtide{data}{ip_units});
                    # msgout($prn);
                    print TFILE "$prn\n";
                }
            }

        }

        close(TFILE);

    }

}  # end sub tides


1;
